---
title: IDBVersionChangeEvent
slug: Web/API/IDBVersionChangeEvent
tags:
  - API
  - DOM
  - Database
  - IDBVersionChangeEvent
  - IndexedDB
  - Interface
  - JavaScript
  - Reference
  - Storage
---
<p>{{APIRef("IndexedDB")}}</p>

<p>The <strong><code>IDBVersionChangeEvent</code></strong> interface of the <a href="/en-US/docs/Web/API/IndexedDB_API">IndexedDB API</a> indicates that the version of the database has changed, as the result of an {{domxref("IDBOpenDBRequest.onupgradeneeded")}} event handler function.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Properties">Properties</h2>

<p><em>Also inherits properties from its parent, {{domxref("Method")}}.</em></p>

<dl>
 <dt>{{ domxref("IDBVersionChangeEvent.oldVersion") }} {{readonlyInline}}</dt>
 <dd>Returns the old version of the database.</dd>
 <dt>{{ domxref("IDBVersionChangeEvent.newVersion") }} {{readonlyInline}}</dt>
 <dd>Returns the new version of the database.</dd>
</dl>

<h3 id="Deprecated_properties">Deprecated properties</h3>

<dl>
 <dt>{{ domxref("IDBVersionChangeEvent.version") }} {{readonlyInline}} {{ Deprecated_inline("") }}</dt>
 <dd>
 <p>The new version of the database in a {{event("versionchange")}} transaction.</p>

 <div class="warning">
 <p><strong>Warning</strong>: While this property is still implemented in older browsers, the latest specification replaces it with the <code>oldVersion</code> and <code>newVersion</code> attributes. See the compatibility table to know what browsers support them.</p>
 </div>
 </dd>
</dl>

<h3 id="Methods">Methods</h3>

<p><em>No specific method, but inherits properties from its parent, {{domxref("Method")}}.</em></p>

<h2 id="Example">Example</h2>

<p>In the following code snippet, we make a request to open a database, and include handlers for the success and error cases. Upon a version change (after an <code>upgradedneeded</code> event), the <code>success</code> event will implement the <code>IDBVersionChangeEvent</code> interface. For a full working example, see our <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> app (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</p>

<pre class="brush:js">var note = document.querySelector("ul");

// In the following line, you should include the prefixes of implementations you want to test.
window.indexedDB = window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
// DON'T use "var indexedDB = ..." if you're not in a function.
// Moreover, you may need references to some window.IDB* objects:
window.IDBTransaction = window.IDBTransaction || window.webkitIDBTransaction || window.msIDBTransaction;
window.IDBKeyRange = window.IDBKeyRange || window.webkitIDBKeyRange || window.msIDBKeyRange;
// (Mozilla has never prefixed these objects, so we don't need window.mozIDB*)

// Let us open version 4 of our database
var DBOpenRequest = window.indexedDB.open("toDoList", 4);

// these two event handlers act on the database being opened successfully, or not
DBOpenRequest.onerror = function(event) {
  note.innerHTML += '&lt;li&gt;Error loading database.&lt;/li&gt;';
};

DBOpenRequest.onsuccess = function(event) {
  note.innerHTML += '&lt;li&gt;Database initialised.&lt;/li&gt;';

  // store the result of opening the database in the db variable. This is used a lot later on, for opening transactions and suchlike.
  db = DBOpenRequest.result;
};
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB', '#idbversionchangeevent', 'IDBVersionChangeEvent')}}</td>
   <td>{{Spec2('IndexedDB')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#idbversionchangeevent", "IDBVersionChangeEvent")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.IDBVersionChangeEvent")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li><a href="/en-US/docs/Web/API/IDBDatabase/onversionchange">IDBDatabase.onversionchange</a></li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
